<?php
/**
 * Project: Very Limited iPad HTML render for SageTV (VLiPad)
 * Version: 0.02
 *    File: index.php
 *     URL: http://forums.sagetv.com/forums/forumdisplay.php?f=27
 * License: Look license.txt
 **/

 date_default_timezone_set("Europe/Oslo");
?>

<?php
//--find all vli file objects, read contents, sort, store in $mediaobjects-----

function cmp_mediaitem($a,$b)
{
 $type_a = strtolower($a["entry_type"]);
 $type_b = strtolower($b["entry_type"]);
 $time_a = $a["entry_time"];
 $time_b = $b["entry_time"];
 $title_a = $a["entry_title"];
 $title_b = $b["entry_title"];
 if($type_a == "tv" && $type_b == "movie")
   return -1;
 if($type_a == "movie" && $type_b == "tv")
   return 1;
 if($type_a == "tv" && $type_b == "tv"){
   if($title_a == $title_b) return (($time_a < $time_b) ? -1 : 1);
   return ($title_a < $title_b) ? -1 : 1;
   }

 if($title_a == $title_b) return 0;
 return ($title_a < $title_b) ? -1 : 1;
}

 unset($emptyitem);
 $emptyitem["vlifilename"]    = "";
 $emptyitem["entry_mp4file"]  = "";
 $emptyitem["entry_channel"]  = "";
 $emptyitem["entry_title"]    = "";
 $emptyitem["entry_time"]     = "";
 $emptyitem["entry_type"]     = "";
 $emptyitem["entry_status"]   = "";
 $emptyitem["entry_bookmark"] = "";

 $parsedir = "./";
 $filelist = scandir($parsedir);

 foreach($filelist as $item){
   $item = trim($item);
   $iL = strlen($item);
   $iP = strpos(strtolower($item),".vli");
   if($iP && $iL >= 5 && $iP == $iL - 4){
     unset($mediaitem);
     $mediaitem = $emptyitem;
     $mediaitem["vlifilename"]  = $item;
     $mediaitem["entry_status"] = "Recoding";

     if($fileh = fopen($mediaitem["vlifilename"],'r')){
       while($fline = fgets($fileh)){
         $fline = trim($fline);
         $iP = strpos($fline,":");
         if(!$iP) continue;
         $tag = trim(strtolower(substr($fline,0,$iP)));
         $value = trim(substr($fline,$iP + 1));
         if($tag == "" || $value == "") continue;
         if($tag == "mp4file")  $mediaitem["entry_mp4file"]  = $value;
         if($tag == "channel")  $mediaitem["entry_channel"]  = $value;
         if($tag == "title")    $mediaitem["entry_title"]    = $value;
         if($tag == "time")     $mediaitem["entry_time"]     = $value;
         if($tag == "type")     $mediaitem["entry_type"]     = $value;
         if($tag == "status")   $mediaitem["entry_status"]   = $value;
         if($tag == "bookmark") $mediaitem["entry_bookmark"] = $value;
         }
       fclose($fileh);
       }

     if(strtolower($mediaitem["entry_status"]) != "done" &&
        strtolower($mediaitem["entry_status"]) != "recoding")
       continue;

     if(strtolower($mediaitem["entry_type"]) == "tv" &&
        ($mediaitem["entry_mp4file"] == "" ||
         $mediaitem["entry_channel"] == "" ||
         $mediaitem["entry_title"]   == "" ||
         $mediaitem["entry_time"]    == ""))
       continue;

     if(strtolower($mediaitem["entry_type"]) == "movie" &&
        ($mediaitem["entry_mp4file"] == "" ||
         $mediaitem["entry_title"]   == ""))
       continue;

     $mediaobjects[] = $mediaitem;
     }
   }

 if(isset($mediaobjects)) uasort($mediaobjects,'cmp_mediaitem');
 $eofitem = $emptyitem;
 $eofitem["entry_type"] = "eof";
 $mediaobjects[] = $eofitem;
?>

<html>
<head>

<!-- no cache headers -->
<meta http-equiv="Pragma" content="no-cache" />
<meta http-equiv="Expires" content="-1" />
<meta http-equiv="Cache-Control" content="no-cache" />

<!-- fix the iPad zoom/rotate logic -->
<meta name="viewport" content="width=1024" />

<!-- title -->
<title>VLiPad SageTV</title>

<!-- stylesheets -->
<link rel="stylesheet" type="text/css" href="index.css" />

<!-- scripts -->
<script type="text/javascript" src="index.js"></script>

</head>
<body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- header row -->
<table cellspacing=0 border=0 cellpadding=0 width=1024>
  <tr>
    <td align=left valign=middle height="55" width="100%" nowrap>&nbsp;<a href="http://forums.sagetv.com/forums/forumdisplay.php?f=27" target="_blank">Very Limited iPad SageTV</a></td>
    <td align=right valign=middle height="55" nowrap><a href="http://www.sagetv.com/" target="_blank"><img src="graphics/logo_sagetv_negative.png" height=30 width=84 /></a>&nbsp;</td>
  </tr>
</table>
<img src="graphics/white_1024x.png" height=1 width=1024 /><br>

<table cellspacing=0 border=0 cellpadding=0 width=1024>
  <tr>
    <td align=center valign=middle height="55" width="100%" nowrap><b>[ &middot; TV Shows &middot; ]</b></td>
  </tr>
</table>
<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>
  
<?php
//--parse, group, output media objects (type: tv)------------------------------

 $out = "";
 $out .= '<!-- tv shows -->' . "\n";

 unset($groupobj);
 $groupobjc = 0;
 $groupobjn = "";
 $groupobjchl = "";
 $groupobjtag = 1;

 foreach($mediaobjects as $item){
   if(strtolower($item["entry_type"]) != "tv" && strtolower($item["entry_type"]) != "eof") continue;

   if($groupobjc <= 0 || $groupobjn == $item["entry_title"]){
     $groupobj[] = $item;
     $groupobjc += 1;
     $groupobjn = $item["entry_title"];
     $groupobjchl = $item["entry_channel"];
     continue;
     }

   //--if only 1 media object, do not group------------------------------------

   if($groupobjc == 1){
     foreach($groupobj as $itemobj){
       $airtime = 0;
       if($itemobj["entry_time"] != 0 && $itemobj["entry_time"] != "") $airtime = date("D d.m H:i",$itemobj["entry_time"] / 1000);
       $titleurl_pre = '<a href="index_play.php?vlifile=' . $itemobj["vlifilename"] . '">';
       $titleurl_post = '</a>';
       $recodetxt = '';
       if(strtolower($itemobj["entry_status"]) == "recoding"){
         $titleurl_pre = '';
         $titleurl_post = '';
         $recodetxt = ' (<i>recoding</i>)';
         }
       $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
       $out .= '  <tr>' . "\n";
       $out .= '    <td align=left  valign=middle height="55" width="225" nowrap>&nbsp;' . $titleurl_pre . '<img src="graphics/button_choose_leftside.png" height=47 width=200 />' . $titleurl_post . '</td>' . "\n";
       $out .= '    <td align=left  valign=middle height="55" width="294" nowrap>' . $titleurl_pre . $itemobj["entry_title"] . $recodetxt . $titleurl_post . '</td>' . "\n";
       $out .= '    <td align=right valign=middle height="55" width="200" nowrap>' . $titleurl_pre . $airtime . $titleurl_post . '</td>' . "\n";
       $out .= '    <td align=right valign=middle height="55" width="80"  nowrap>' . $titleurl_pre . '<img src="ChannelLogos/' . $itemobj["entry_channel"] . '.png" height=45 width=64 />' . $titleurl_post . '</td>' . "\n";
       $out .= '    <td align=right valign=middle height="55" width="225" nowrap>' . $titleurl_pre . '<img src="graphics/button_choose_rightside.png" height=47 width=200 />' . $titleurl_post . '&nbsp;</td>' . "\n";
       $out .= '  </tr>' . "\n";
       $out .= '</table>' . "\n";
       $out .= '<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>' . "\n";
       }
     unset($groupobj);
     $groupobj[] = $item;
     $groupobjc = 1;
     $groupobjn = $item["entry_title"];
     $groupobjchl = $item["entry_channel"];
     continue;
     }

   //--several identical media objects, group them-----------------------------

   $thisDivTag = "group" . $groupobjtag . "Tag";
   $thisImgTagLeft = "group" . $groupobjtag . "ImgLeft";
   $thisImgTagRight = "group" . $groupobjtag . "ImgRight";
   $titleurl = '<a href="#" onclick="toggleShowExpand(\'' . $thisDivTag . '\',\'' . $thisImgTagLeft . '\',\'' . $thisImgTagRight . '\')">';

   $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
   $out .= '  <tr>' . "\n";
   $out .= '    <td align=left  valign=middle height="55" width="225" nowrap>&nbsp;' . $titleurl . '<img src="graphics/button_expand_leftside.png" id="' . $thisImgTagLeft . '" height=47 width=200 /></a></td>' . "\n";
   $out .= '    <td align=left  valign=middle height="55" width="294" nowrap>' . $titleurl . $groupobjn . '</a></td>' . "\n";
   $out .= '    <td align=right valign=middle height="55" width="200" nowrap>' . $titleurl . '(' . $groupobjc . 'x)</a></td>' . "\n";
   $out .= '    <td align=right valign=middle height="55" width="80"  nowrap>' . $titleurl . '<img src="ChannelLogos/' . $groupobjchl . '.png" height=45 width=64 /></a></td>' . "\n";
   $out .= '    <td align=right valign=middle height="55" width="225" nowrap>' . $titleurl . '<img src="graphics/button_expand_rightside.png" id="' . $thisImgTagRight . '" height=47 width=200 /></a>&nbsp;</td>' . "\n";
   $out .= '  </tr>' . "\n";
   $out .= '</table>' . "\n";
   $out .= '<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>' . "\n";

   $out .= '<div id="' . $thisDivTag . '">' . "\n";
   foreach($groupobj as $itemobj){
     $airtime = 0;
     if($itemobj["entry_time"] != 0 && $itemobj["entry_time"] != "") $airtime = date("D d.m H:i",$itemobj["entry_time"] / 1000);
     $titleurl_pre = '<a href="index_play.php?vlifile=' . $itemobj["vlifilename"] . '">';
     $titleurl_post = '</a>';
     $recodetxt = '';
     if(strtolower($itemobj["entry_status"]) == "recoding"){
       $titleurl_pre = '';
       $titleurl_post = '';
       $recodetxt = ' (<i>recoding</i>)';
       }
     $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
     $out .= '  <tr>' . "\n";
     $out .= '    <td align=left  valign=middle height="55" width="225" nowrap>&nbsp;' . $titleurl_pre . '<img src="graphics/button_choose_leftside.png" height=47 width=200 />' . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=left  valign=middle height="55" width="294" nowrap>' . $titleurl_pre . '&raquo;&nbsp;' . $itemobj["entry_title"] . $recodetxt . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="200" nowrap>' . $titleurl_pre . $airtime . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="80"  nowrap>' . $titleurl_pre . '<img src="ChannelLogos/' . $itemobj["entry_channel"] . '.png" height=45 width=64 />' . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="225" nowrap>' . $titleurl_pre . '<img src="graphics/button_choose_rightside.png" height=47 width=200 />' . $titleurl_post . '&nbsp;</td>' . "\n";
     $out .= '  </tr>' . "\n";
     $out .= '</table>' . "\n";
     $out .= '<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>' . "\n";
     }
   $out .= '</div>' . "\n";
   $out .= '<script language="javascript" type="text/javascript">toggleShow(\'' . $thisDivTag . '\');</script>' . "\n";
   
   unset($groupobj);
   $groupobj[] = $item;
   $groupobjc = 1;
   $groupobjn = $item["entry_title"];
   $groupobjchl = $item["entry_channel"];
   $groupobjtag += 1;
   }

 echo $out;
?>

<table cellspacing=0 border=0 cellpadding=0 width=1024>
  <tr>
    <td align=center valign=middle height="55" width="100%" nowrap><b>[ &middot; Movies &middot; ]</b></td>
  </tr>
</table>
<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>

<?php
//--parse, output media objects (type: movie)----------------------------------

 $out = "";
 $out .= '<!-- movies -->' . "\n";

 foreach($mediaobjects as $item){
   $titleurl_pre = '<a href="index_play.php?vlifile=' . $item["vlifilename"] . '">';
   $titleurl_post = '</a>';
   $recodetxt = '';
   if(strtolower($item["entry_type"]) == "movie"){
     if(strtolower($item["entry_status"]) == "recoding"){
       $titleurl_pre = '';
       $titleurl_post = '';
       $recodetxt = ' (<i>recoding</i>)';
       }
     $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
     $out .= '  <tr>' . "\n";
     $out .= '    <td align=left  valign=middle height="55" width="225" nowrap>&nbsp;' . $titleurl_pre . '<img src="graphics/button_choose_leftside.png" height=47 width=200 />' . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=left  valign=middle height="55" width="294" nowrap>' . $titleurl_pre . $item["entry_title"] . $recodetxt . $titleurl_post  . '</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="200" nowrap>&nbsp;</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="80"  nowrap>' . $titleurl_pre . '<img src="graphics/logo_movie.png" height=45 width=64 />' . $titleurl_post . '</td>' . "\n";
     $out .= '    <td align=right valign=middle height="55" width="225" nowrap>' . $titleurl_pre . '<img src="graphics/button_choose_rightside.png" height=47 width=200 />' . $titleurl_post . '&nbsp;</td>' . "\n";
     $out .= '  </tr>' . "\n";
     $out .= '</table>' . "\n";
     $out .= '<img src="graphics/gray_1024x.png" height=1 width=1024 /><br>' . "\n";
     }
   }

 echo $out;
?>

<!-- footer row -->
<br><br>
<img src="graphics/white_1024x.png" height=1 width=1024 /><br>
<table cellspacing=0 border=0 cellpadding=0 width=1024>
  <tr>
    <td align=right valign=middle height="55" width="100%" nowrap>&lt;eof&gt;&nbsp;</td>
  </tr>
</table>

</body>
</html>
