<?php
/**
 * Project: Very Limited iPad HTML render for SageTV (VLiPad)
 * Version: 0.02
 *    File: index_play.php
 *     URL: http://forums.sagetv.com/forums/forumdisplay.php?f=27
 * License: Look license.txt
 **/

 date_default_timezone_set("Europe/Oslo");
?>
<?php
//--parse and check parameters (try making sure filename is safe)--------------

 unset($mediaitem);
 $mediaitem["vlifilename"]    = "";
 $mediaitem["entry_mp4file"]  = "";
 $mediaitem["entry_channel"]  = "";
 $mediaitem["entry_title"]    = "";
 $mediaitem["entry_time"]     = "";
 $mediaitem["entry_type"]     = "";
 $mediaitem["entry_status"]   = "";
 $mediaitem["entry_bookmark"] = "";

 $errormsg = "";

 while(1){
   $vlifile = "";
   if(isset($_GET['vlifile'])) $vlifile = html_entity_decode($_GET['vlifile']);
   trim($vlifile);
   
   $vlifile_ok = false;
   while(1){
     if($vlifile == "") break;
     if(!preg_match('/^(((?:\.)(?!\.))|\w|\x2D|\x20)+$/',$vlifile)) break;
     $iL = strlen($vlifile);
     $iP = strpos(strtolower($vlifile),".vli");
     if(!($iP && $iL >= 5 && $iP == $iL - 4)) break;
   
     $vlifile_ok = true;
     break;
     }
   if($vlifile_ok == false){
     $errormsg = "ERROR: Invalid format of vlifile input !" . "(" . $vlifile . ")";
     break;
     }
  
//--open/read file, make sure it exists, and is correct format-----------------

   if(!file_exists($vlifile)){
     $errormsg = "ERROR: Not able to access vlifile !";
     break;
     }
  
   $mediaitem["vlifilename"]  = $vlifile;
   $mediaitem["entry_status"] = "Recoding";
  
   if($fileh = fopen($mediaitem["vlifilename"],'r')){
     while($fline = fgets($fileh)){
       $fline = trim($fline);
       $iP = strpos($fline,":");
       if(!$iP) continue;
       $tag = trim(strtolower(substr($fline,0,$iP)));
       $value = trim(substr($fline,$iP + 1));
       if($tag == "" || $value == "") continue;
       if($tag == "mp4file")  $mediaitem["entry_mp4file"]  = $value;
       if($tag == "channel")  $mediaitem["entry_channel"]  = $value;
       if($tag == "title")    $mediaitem["entry_title"]    = $value;
       if($tag == "time")     $mediaitem["entry_time"]     = $value;
       if($tag == "type")     $mediaitem["entry_type"]     = $value;
       if($tag == "status")   $mediaitem["entry_status"]   = $value;
       if($tag == "bookmark") $mediaitem["entry_bookmark"] = $value;
       }
     fclose($fileh);
     }
   else{
     $errormsg = "ERROR: Not able to open vlifile !";
     break;
     }
  
   if(strtolower($mediaitem["entry_status"]) == "recoding"){
     $errormsg = "ERROR: vlifile indicated as still recoding !";
     break;
     }
  
   if((strtolower($mediaitem["entry_type"]) != "tv" && strtolower($mediaitem["entry_type"]) != "movie") || $mediaitem["entry_mp4file"] == "" || $mediaitem["entry_title"] == ""){
     $errormsg = "ERROR: Not a valid vlifile !";
     break;
     }

   break;
   }
?>

<html>
<head>

<!-- no cache headers -->
<meta http-equiv="Pragma" content="no-cache" />
<meta http-equiv="Expires" content="-1" />
<meta http-equiv="Cache-Control" content="no-cache" />

<!-- fix the iPad zoom/rotate logic -->
<meta name="viewport" content="width=1024" />

<?php
 $out = "";

 if(strtolower($mediaitem["entry_type"]) != "tv")
   $subout = $mediaitem["entry_title"];
 else{
   $airtime = 0;
   if($mediaitem["entry_time"] != 0 && $mediaitem["entry_time"] != "") $airtime = date("D d.m H:i",$mediaitem["entry_time"] / 1000);  
   $subout = $mediaitem["entry_title"] . " &middot; " . $airtime . " &middot; " . $mediaitem["entry_channel"];
   }

 $out = "";
 $out .= '<!-- title -->' . "\n";
 $out .= '<title>VLiPad SageTV (' . $subout . ')</title>' . "\n";
 $out .= "\n";

 $out .= '<!-- stylesheets -->' . "\n";
 $out .= '<link rel="stylesheet" type="text/css" href="index_play.css" />' . "\n";
 $out .= "\n";

 $out .= '</head>' . "\n";
 $out .= '<body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0" onunload="saveBookmark()">' . "\n";
 $out .= "\n";

 $out .= '<!-- header row -->' . "\n";
 $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
 $out .= '  <tr>' . "\n";
 $out .= '    <td align=left valign=middle height="55" nowrap>&nbsp;' . $subout . '</td>' . "\n";
 $out .= '    <td align=center valign=middle height="55" width="100%" nowrap><a href="http://www.sagetv.com/" target="_blank"><img src="graphics/logo_sagetv_negative.png" height=30 width=84 /></a>&nbsp;</td>' . "\n";
 $out .= '    <td align=right valign=middle height="55" nowrap><a href="http://forums.sagetv.com/forums/forumdisplay.php?f=27" target="_blank">Very Limited iPad SageTV</a>&nbsp;</td>' . "\n";
 $out .= '  </tr>' . "\n";
 $out .= '</table>' . "\n";
 $out .= "\n";

 $out .= '<!-- video area -->' . "\n";
 $out .= '<img src="graphics/white_1024x.png" height=1 width=1024 /><br>' . "\n";
 if($errormsg == "")
   $out .= '<video controls="controls" height="576" width="1024" src="' . $mediaitem["entry_mp4file"] . '"><br>&nbsp;<i>ERROR: Cannot display video, browser does not support the HTML5 video tag !</i><br></video><br>' . "\n";
 else
   $out .= '<br>&nbsp;<i>' . $errormsg . '</i><br><br>' . "\n";
 $out .= '<img src="graphics/white_1024x.png" height=1 width=1024 /><br>' . "\n";
 $out .= "\n";

 $out .= '<!-- footer row -->' . "\n";
 $out .= '<table cellspacing=0 border=0 cellpadding=0 width=1024>' . "\n";
 $out .= '  <tr>' . "\n";
 $out .= '    <td align=left valign=bottom width="340" height="55">&nbsp;' .
               '<input type="image" src="graphics/button_play.png" value="Play" id="playpause" onclick="playOrPause()" height=47 width=47 />&nbsp;&nbsp;&nbsp;&nbsp;' .
               '<a href="#" onclick="rew5min()"><img src="graphics/button_rew5min.png" height=47 width=47 /></a>&nbsp;&nbsp;' .
               '<a href="#" onclick="rew1min()"><img src="graphics/button_rew1min.png" height=47 width=47 /></a>&nbsp;&nbsp;' .
               '<a href="#" onclick="fwd1min()"><img src="graphics/button_fwd1min.png" height=47 width=47 /></a>&nbsp;&nbsp;' .
               '<a href="#" onclick="fwd5min()"><img src="graphics/button_fwd5min.png" height=47 width=47 /></a>&nbsp;&nbsp;' .
               '</td>' . "\n";
 $out .= '    <td align=left valign=middle width="552" height="55"><div id="playbar"><div id="playbarbuffer"><div id="playbarprogress"></div></div></div></td>' . "\n";
 $out .= '    <td align=right valign=bottom width="132" height="55"><a href="index.php"><img src="graphics/button_back.png" height=47 width=89 /></a>&nbsp;</td>' . "\n";
 $out .= '  </tr>' . "\n";
 $out .= '</table>' . "\n";
 $out .= "\n";

 $out .= '<!-- scripts -->' . "\n";
 $out .= '<script type="text/javascript">' . "\n";
 if($mediaitem["entry_bookmark"] != "" && $mediaitem["entry_bookmark"] >= 0 && $mediaitem["entry_bookmark"] <= 604800){
   $out .= '  var dobookmark = 1;' . "\n";
   $out .= '  var dobookmark_time = ' . $mediaitem["entry_bookmark"] . ';' . "\n";
   }
 else{
   $out .= '  var dobookmark = 0;' . "\n";
   $out .= '  var dobookmark_time = 0;' . "\n";
   }
 $out .= '</script>' . "\n";
 $out .= '<script type="text/javascript" src="index_play.js"></script>' . "\n";

 echo $out;
?>

</body>
</html>
