<?php
/**
 * Project: Very Limited iPad HTML render for SageTV (VLiPad)
 * Version: 0.02
 *    File: index_sbmark.php
 *     URL: http://forums.sagetv.com/forums/forumdisplay.php?f=27
 * License: Look license.txt
 **/

 date_default_timezone_set("Europe/Oslo");
?>
<?php
 header("Content-type: text/xml");

//--parse and check parameters (try making sure filename is safe)--------------

 $bmfile = "";
 if(isset($_GET['vlifile'])) $bmfile = html_entity_decode($_GET['vlifile']);
 trim($bmfile);

 $bmfile_ok = false;
 while(1){
   if($bmfile == "") break;
   if(!preg_match('/^(((?:\.)(?!\.))|\w|\x2D|\x20)+$/',$bmfile)) break;
   $iL = strlen($bmfile);
   $iP = strpos(strtolower($bmfile),".vli");
   if(!($iP && $iL >= 5 && $iP == $iL - 4)) break;

   $bmfile_ok = true;
   break;
   }
 if($bmfile_ok == false){
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>invalid format of vlifile input</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

 $bmtime = -1;
 if(isset($_GET['time'])) $bmtime = intval(html_entity_decode($_GET['time']));
 if($bmtime < 0 || $bmtime > 604800){
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>invalid format of time input (valid range: 0 - 604800)</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

//--open/read file, make sure it exists, and is correct format-----------------

 if(!file_exists($bmfile)){
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>not able to access vlifile</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

 unset($mediaitem);
 $mediaitem["vlifilename"]    = "";
 $mediaitem["entry_mp4file"]  = "";
 $mediaitem["entry_channel"]  = "";
 $mediaitem["entry_title"]    = "";
 $mediaitem["entry_time"]     = "";
 $mediaitem["entry_type"]     = "";
 $mediaitem["entry_status"]   = "";
 $mediaitem["entry_bookmark"] = "";

 $mediaitem["vlifilename"]  = $bmfile;
 $mediaitem["entry_status"] = "Recoding";

 if($fileh = fopen($mediaitem["vlifilename"],'r')){
   while($fline = fgets($fileh)){
     $fline = trim($fline);
     $iP = strpos($fline,":");
     if(!$iP) continue;
     $tag = trim(strtolower(substr($fline,0,$iP)));
     $value = trim(substr($fline,$iP + 1));
     if($tag == "" || $value == "") continue;
     if($tag == "mp4file")  $mediaitem["entry_mp4file"]  = $value;
     if($tag == "channel")  $mediaitem["entry_channel"]  = $value;
     if($tag == "title")    $mediaitem["entry_title"]    = $value;
     if($tag == "time")     $mediaitem["entry_time"]     = $value;
     if($tag == "type")     $mediaitem["entry_type"]     = $value;
     if($tag == "status")   $mediaitem["entry_status"]   = $value;
     if($tag == "bookmark") $mediaitem["entry_bookmark"] = $value;
     }
   fclose($fileh);
   }
 else{
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>not able to open vlifile</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

 if(strtolower($mediaitem["entry_status"]) == "recoding"){
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>vlifile indicated as still recoding</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

 if((strtolower($mediaitem["entry_type"]) != "tv" && strtolower($mediaitem["entry_type"]) != "movie") || $mediaitem["entry_mp4file"] == "" || $mediaitem["entry_title"] == ""){
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>not a valid vlifile</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

//--overwrite file with existing contents and new bookmark---------------------

 if($bmtime != "") $mediaitem["entry_bookmark"] = $bmtime;

 if($fileh = fopen($mediaitem["vlifilename"],'w')){
   if($mediaitem["entry_mp4file"]  != "") fwrite($fileh,"MP4File: "  . $mediaitem["entry_mp4file"]  . "\n");
   if($mediaitem["entry_channel"]  != "") fwrite($fileh,"Channel: "  . $mediaitem["entry_channel"]  . "\n");
   if($mediaitem["entry_title"]    != "") fwrite($fileh,"Title: "    . $mediaitem["entry_title"]    . "\n");
   if($mediaitem["entry_time"]     != "") fwrite($fileh,"Time: "     . $mediaitem["entry_time"]     . "\n");
   if($mediaitem["entry_type"]     != "") fwrite($fileh,"Type: "     . $mediaitem["entry_type"]     . "\n");
   if($mediaitem["entry_status"]   != "") fwrite($fileh,"Status: "   . $mediaitem["entry_status"]   . "\n");
   if($mediaitem["entry_bookmark"] != "") fwrite($fileh,"Bookmark: " . $mediaitem["entry_bookmark"] . "\n"); 
   fclose($fileh);
   }
 else{
   echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>error</result>' . "\n" . '  <message>not able to write to vlifile</message>' . "\n" . '</savebookmark>' . "\n";
   exit(0);
   }

//--give a plain 'ok' type of xml response-------------------------------------

 echo '<?xml version="1.0"?>' . "\n" . '<savebookmark>' . "\n" . '  <result>ok</result>' . "\n" . '  <message></message>' . "\n" . '</savebookmark>' . "\n";
?>
